(function ($) {
  Drupal.behaviors.admin_notes = {
  attach: function (context, settings) {
    $('#admin-toolbar form#admin-notes-block-form input.save-button, #admin-toolbar form#admin-notes-block-form input.delete-button').click(function(event) {
      // Prevent the default link action - we don't
      // want to trigger a synchronous response.
      event.preventDefault();
      
      op = $(this).val();
      
  /* IF THERE IS A BETTER WAY TO IMPLEMENT THIS SECTION THAT YOU KNOW OF PLEASE SUBMIT A PATCH!! */
      // We need to get the current location that we are on
      var loc = window.location.toString();
      // Now we need to strip away the first part of the location
      // For example if our path (location from above) is http://www.example.com/path/1/2/3
      // we want to remove http://www.example.com
      var domainAddress = window.location.href.match(/(https{0,1}:\/\/[0-9a-z\.]*)/)[1];
      // Now we get the rest of the current path, excluding the domain name
      var relativePath = loc.replace(domainAddress, '');
  /*  END  */    
      
      // In case Drupal is in a subdirectory remove it from the path stored in the database
      adminNotesPath = relativePath.replace(Drupal.settings.basePath, '');
      
      // If the adminNotesPath is blank (because activePath and basePath above are the same)
      // then we are on the homepage and we need to manually set the path
      if (adminNotesPath == '') {  adminNotesPath = '/';  }
      $.ajax({
        type: "GET", // Should this be changed to POST...or does it matter?
        url: Drupal.settings.basePath + "admin_notes/submit", // Using basePath in case Drupal is in a subdirectory
        data: {
          'note' : $('form#admin-notes-block-form textarea').val(), // Get value of textarea
          'path' : adminNotesPath,
          'op'   : op
        },
        success: function(msg) {
          if (op == 'Save') {
            // Add class to show the 'note present' icon
            $('body').addClass('admin-notes-exists');
            $('form#admin-notes-block-form #edit-submit').addClass('delete-show');
            $('form#admin-notes-block-form #edit-submit').val('Update');
            $('form#admin-notes-block-form #edit-delete').css('display', 'block');
          }
          else if (op == 'Delete') {
            // Remove class to hide the 'note present' icon
            $('body').removeClass('admin-notes-exists');
            $('form#admin-notes-block-form textarea').val('');
            $('form#admin-notes-block-form #edit-submit').removeClass('delete-show');
            $('form#admin-notes-block-form #edit-submit').val('Save');
            $('form#admin-notes-block-form #edit-delete').css('display', 'none');
          }
          
          // Add the message to the Admin Notes area
          $('#block-admin_notes-notes .block-content').prepend('<div class="notification">' + msg + '</div>');
          
          // Hide the message after a bit of time
          // Using .animate to 'delay' the fadeOut effect
          $('#block-admin_notes-notes .notification').animate({opacity: 1.0}, 3000).fadeOut('slow');
        }
      });
    });
  }
  }
})(jQuery);